union REGS regs;
struct SREGS sregs;
int pageno;
int colors;
char tempfilename[] = "logo.tmp";
unsigned graphbuf[640];
long tempfilepos = 0;

void initgraph(void);
void closegraph(void);
void screenon (int sw);
void setpage(int page);
void putpixel(unsigned x,unsigned y,unsigned color);
unsigned getpixel(unsigned x,unsigned y);
int setcolor(int reds, int greens, int blues);
long imagesize(int x1,int y1,int x2,int y2);
void cleardevice(void);
void getimage(int x1,int y1,int x2,int y2,unsigned *p);
void putimage(int x1,int y1,int x2,int y2,unsigned *p);
long getimage1(int x1,int y1,int x2,int y2);
void putimage1(int x1,int y1,int x2,int y2,long fpseek);
void bar (int x1,int y1,int x2,int y2);
void line(int x1,int y1,int x2,int y2);
int d_to_i(double d);
void showbmp(char *path, char *filename,double x,double y);
void deletetempfile();

void initgraph(void)
{
  regs.x.ax=0x4f02;
  regs.x.bx=0x0111;
  int86(0x10,&regs,&regs);
  pageno=0;
}
void closegraph(void)
{
  regs.x.ax=3;
  int86(0x10,&regs,&regs);
}
void screenon (int sw)
{
	switch(sw)
	{
	case 0:
		asm {
		mov ax,0x1201
		mov bl,0x36
		int 0x10}
		break;
	case 1:
		asm {
		mov ax,0x1200
		mov bl,0x36
		int 0x10}
		break;
	}
}
void setpage(int page)
{
  if (page!=pageno)
  {
    pageno=page;
    regs.x.ax=0x4f05;
    regs.x.bx=0;
    regs.x.dx=pageno;
    int86(0x10,&regs,&regs);
  }
}
void putpixel(unsigned x,unsigned y,unsigned color)
{
  asm {
    mov ax,y
    mov bx,1280
    mul bx
    shl x,1
    add ax,x
    jnc jemp1
    inc dx
  }
  jemp1:
  asm {
    mov di,ax
    cmp dx,pageno
    je jemp2
    mov pageno,dx
    mov ax,0x4f05
    mov bx,0x0000
    int 0x10
  }
  jemp2:
  asm {
    mov ax,0xa000
    mov es,ax
    mov ax,color
    stosw
  }
}
unsigned getpixel(unsigned x,unsigned y)
{
  asm {
    mov ax,y
    mov bx,1280
    mul bx
    shl x,1
    add ax,x
    jnc jemp1
	inc dx
  }
  jemp1:
  asm {
	mov di,ax
	cmp dx,pageno
	je jemp2
	mov pageno,dx
	mov ax,0x4f05
	mov bx,0x0000
	int 0x10
  }
  jemp2:
  asm {
    mov ax,0xa000
    mov es,ax
    mov ax,es:[di]
  }
  return(_AX);
}
int setcolor(int reds, int greens, int blues)
{
	colors=reds*2048+greens*64+blues;
	return colors;
}
long imagesize(int x1,int y1,int x2,int y2)
{
  long t;
  t = (long)(x2 - x1 + 1) * (y2 - y1 + 1) * 2;
  if(t > 60000)
   return(-1);
  else
   return(t);
}
void cleardevice(void)
{
	int i;
	asm {
	mov ax,0x1201
	mov bl,0x36
	int 0x10
	}
	for (i=0;i<15;i++)
	asm {
		mov ax,0x4f05
		mov bx,0x0000
		mov dx,i
		int 0x10
		mov ax,0xa000
		mov es,ax
	mov di,0x0000
		mov ax,0x0000
		mov cx,0x8000
		rep stosw
		mov ax,0x1200
		mov bl,0x36
		int 0x10
	}
}
void getimage(int x1,int y1,int x2,int y2,unsigned *p)
{
	int i,j;
	for(i = x1;i <= x2;i++)
	 for(j = y1;j <= y2;j++)
	{
		*p=getpixel(i,j);
		p++;
	}
}
void putimage(int x1,int y1,int x2,int y2,unsigned *p)
{
	int i,j;
	for(i = x1;i <= x2;i++)
	 for(j = y1;j <= y2;j++)
	{
		putpixel(i,j,*p);
		p++;
	}
}
long getimage1(int x1,int y1,int x2,int y2)
{
  FILE *fptemp;
  long i,j,k,pos;
  fptemp=fopen(tempfilename,"w+b");
  fseek(fptemp,tempfilepos,SEEK_SET);
  pos=tempfilepos;
  for (i=y1;i<=y2;i++)
  {
    k=0;
    for (j=x1;j<=x2;j++) graphbuf[k++]=getpixel(j,i);
    fwrite(graphbuf,(x2-x1+1)*2,1,fptemp);
  }
  tempfilepos=ftell(fptemp);
  fclose(fptemp);
  return(pos);
}
void putimage1(int x1,int y1,int x2,int y2,long fpseek)
{
  FILE *fptemp;
  long i,j,k;
  fptemp=fopen(tempfilename,"r+b");
  fseek(fptemp,fpseek,SEEK_SET);
  for (i=y1;i<=y2;i++)
  {
    fread(graphbuf,(x2-x1+1)*2,1,fptemp);
    k=0;
    for (j=x1;j<=x2;j++) putpixel(j,i,graphbuf[k++]);
  }
  fclose(fptemp);
}
void bar (int x1,int y1,int x2,int y2)
{
	int minx = (x1 <= x2) ? x1 : x2,miny = (y1 <= y2) ? y1 : y2,maxx = (x1 >= x2) ? x1 : x2,maxy = (y1 >= y2) ? y1 : y2;
	int i,j;
	for (j=miny;j<=maxy;j++)
	 for (i=minx;i<=maxx;i++)
		putpixel (i,j,colors);
}
void line(int x1,int y1,int x2,int y2)
{
	double _x1 = (double)x1,_y1 = (double)y1,_x2 = (double)x2,_y2 = (double)y2;
	int i;
	int dx = x2 - x1,dy = y2 - y1;
	int markx,marky;
	double ky;
	double kx;

	if((x1 != x2) && (y1 != y2))
	{
		markx = dx / abs(dx);
		marky = dy / abs(dy);
		ky = (_y2 - _y1) / (_x2 - _x1);
		kx = (_x2 - _x1) / (_y2 - _y1);
		if(abs(dx) >= abs(dy))
			for(i = 0;i != x2 - x1;i += markx)
				putpixel(x1 + i,d_to_i(_y1 + i * ky),colors);
		else
			for(i = 0;i != y2 - y1;i += marky)
				putpixel(d_to_i(_x1 + i * kx),y1 + i,colors);
		putpixel(x2,y2,colors);
	}
	else
	 bar(x1,y1,x2,y2);
}
int d_to_i(double d)
{
	int i = 0;

	if(d > 0)
	{
		if(d - (int)d >= 0.5)
		 i = (int)d + 1;
		else
		 i = (int)d;
	}
	if(d < 0)
	{
		if((int)d - d >= 0.5)
		 i = (int)d - 1;
		else
		 i = (int)d;
	}
	return i;
}
void showbmp(char *path,char *file,double x,double y)
{
  FILE *fp;
  long i,j,w,h;
  char filename[MAX_LINE+20];

  strcpy(filename,path);
  strcat(filename,file);
  fp=fopen(filename,"r");
  fseek(fp,18,SEEK_SET);
  fread(&w,4,1,fp);
  fread(&h,4,1,fp);
  fseek(fp,54,SEEK_SET);
  for (i=h-1;i>=0;i--) for (j=0;j<w;j++)
    putpixel(x+j,y+i,setcolor(fgetc(fp)/8,fgetc(fp)/8,fgetc(fp)/8));
  fclose(fp);
}
void deletetempfile()
{
  remove(tempfilename);
}